﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 스케일 변환
        /// </summary>
        private ScaleTransform scaleTransform;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.scaleTransform = new ScaleTransform(1,1);

            Button button = new Button();

            button.Margin              = new Thickness(20);
            button.HorizontalAlignment = HorizontalAlignment.Left;
            button.VerticalAlignment   = VerticalAlignment.Top;
            button.Width               = 100;
            button.Height              = 30;
            button.RenderTransform     = this.scaleTransform;
            button.Content             = "버튼";

            button.Click += button_Clicked;

            Content = button;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 버튼 클릭시 처리하기 - button_Clicked(sender, e)

        /// <summary>
        /// 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void button_Clicked(object sender, RoutedEventArgs e)
        {
            DoubleAnimation doubleAnimation = new DoubleAnimation(1, 5, new Duration(TimeSpan.FromSeconds(5)));

            doubleAnimation.AutoReverse = true;

            AnimationClock animationClock = doubleAnimation.CreateClock();

            scaleTransform.ApplyAnimationClock(ScaleTransform.ScaleXProperty, animationClock);
            scaleTransform.ApplyAnimationClock(ScaleTransform.ScaleYProperty, animationClock);
        }

        #endregion
    }
}